/* Copyright (c) 2012   Guy WEILER         weigu[at]weigu[dot]lu

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   Licence: GPL-3        */

#include <iostream>
#include <cstdio>
#include <unistd.h>
#include "hidapi.h"

/* Linux */
/*#include <linux/types.h>
#include <linux/input.h>
#include <linux/hidraw.h>*/

/* Unix */
/*#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>*/



using namespace std;

hid_device *handle;

hid_device* open_hid_device(void)
{
  // Open the device using the VID, PID,
  // and optionally the Serial number.
  hid_device *handle;
  int nonblockres;
  handle = hid_open(0x3eb, 0x003, NULL);
  if (handle == NULL) cout << "error hid_open: handle = NULL" << endl;
  else
  {
    // Set the hid_read() function to be non-blocking.
    nonblockres = hid_set_nonblocking(handle, 1);
    if (nonblockres == -1) cout << "error hid_set_nonblocking = -1" << endl;
  }
  return handle;
}


void send_to_port(unsigned char Port)
{
  unsigned char buf[2];
  hid_device *handle;
  int res;
  handle = open_hid_device();
  if (handle != NULL)
  {
    buf[0] = 0;
    buf[1] = Port;
    res = hid_write(handle, buf, 2);
    if (res < 0) cout << "Fehler beim Schreiben aufgetreten!\n";
  }
  hid_close(handle);
}

unsigned int get_once_from_adc()
{
  unsigned int adcvalue,adcvalue1,adcvalue2,adcvalue3;
  unsigned char buf[4];
  hid_device *handle;
  int res;
  handle = open_hid_device();
  if (handle != NULL)
  {
    usleep(4000);         //!! Timing-Problem falls kleiner!
    res = hid_read(handle, buf, 2);
    if (res < 0) cout << "Fehler beim Lesen aufgetreten!\n";
    adcvalue = (unsigned int) (buf[1]*256)+buf[0];
    adcvalue1 = (unsigned int) buf[0];
    adcvalue2 = (unsigned int) buf[1];
    adcvalue3 = (unsigned int) buf[2];
    cout << res << "   0 " << adcvalue1 << "   1 " << adcvalue2 << "   2 " << adcvalue3 << endl;
  }
  hid_close(handle);
  return adcvalue;
}

