/* Copyright (c) 2012   Guy WEILER         weigu[at]weigu[dot]lu

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   Licence: GPL-3        */

#include <iostream>
#include <cstdio>

/* Linux */
#include <linux/types.h>
#include <linux/input.h>
#include <linux/hidraw.h>

/* Unix */
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

using namespace std;


int open_hid_device(void)
{
  /* Open the Device with non-blocking reads. In real life,
     don't use a hard coded path; use libudev instead. */
  int fd;
  fd = open("/dev/hidraw0", O_RDWR|O_NONBLOCK);
  if (fd < 0) cout << "Fehler beim Öffnen des Gerätes!\n";
  return fd;
}


void send_to_port(unsigned char Port)
{
  unsigned char buf[2];
  int fd,res;
  fd = open_hid_device();  
  buf[0] = Port;
  res = write(fd, buf, 2);
  if (res < 0) cout << "Fehler beim Schreiben aufgetreten!\n";
  close(fd);
}


unsigned int get_once_from_adc()
{
  unsigned int adcvalue;
  unsigned char buf[4];
  int fd, res;
  fd = open_hid_device();
  usleep(4000);         //!! Timing-Problem falls kleiner!
  res = read(fd, buf, 2);
  if (res < 0) cout << "Fehler beim Lesen aufgetreten!\n";
  adcvalue = (unsigned int) (buf[1]*256)+buf[0];
  close(fd);
  return adcvalue;
}
